package com.zhentao.domain;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;
import lombok.Data;

/**
 * 订单详情表
 * @TableName order_shopping
 */
@TableName(value ="order_shopping")
@Data
public class OrderShopping implements Serializable {
    /**
     * 详情id
     */
    @TableId
    private Long id;

    /**
     * 订单id
     */
    private Long orderId;

    /**
     * 店铺id
     */
    private Long shopId;

    /**
     * 订单详细id
     */
    private Long courseDatailsId;

    /**
     * 名称
     */
    private String titleName;


    /**
     * 单价
     */
    private BigDecimal price;


    /**
     * 创建时间
     */
    private Date createTime;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;
}
