package com.zhentao.domain;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;
import lombok.Data;

/**
 *
 * @TableName user_coupon
 */
@TableName(value ="user_coupon")
@Data
public class UserCoupon implements Serializable {
    /**
     * 用户ID
     */
    private Long uid;

    /**
     * 优惠券ID
     */
    private Long cid;

    /**
     * 状态(1:未使用,2:已使用,3:已过期)
     */
    private Integer status;
    @TableField(exist = false)
    private static final long serialVersionUID = 1L;
}
